clear

% problem size
m = 30;
n = 20;
[cols,rows] = meshgrid(1:n,1:m);

% disk parameters
cx = 8;
cy = 20;
r = 5;

% create matrix with disk
X = (rows - cy).^2 + (cols - cx).^2 <= r^2;

figure
imagesc(X)
colormap gray
title('f(x,y)')
fig = gcf;
fout = './fxy_matlab';
print(fig,fout,'-depsc')

% test your first diffs matrix
A = first_diffs_2d_matrix(m,n);

x = X(:);
DFDX = A(1:m*n,:)*x;
DFDY = A(m*n+1:2*m*n,:)*x;

figure
imagesc(reshape(DFDX,m,n))
colormap gray
title('df(x,y)/dx')
fig = gcf;
fout = './dfdx_matlab';
print(fig,fout,'-depsc')

figure
imagesc(reshape(DFDY,m,n))
colormap gray
title('df(x,y)/dy')
fig = gcf;
fout = './dfdy_matlab';
print(fig,fout,'-depsc')
